Multilingual SemanticMediaWiki
Closed, InvalidPublic

Description

Semantic MediaWiki would benefit from being multilingual-capable out of the box. We could integrate it with the Translate extension. This can be done in some isolated steps, but there is a need to list all the things in need of translation and define appproach and priority for each of them. Some of the steps could be:

  1. Fix the issues that prevent full localisation of Semantic Forms.
  2. Enhance Special:CreateForm and friends (all the Special:Create* special pages by Semantic Forms) to create forms that are already i18n -ed with placeholders and message group for Translate extension.
  3. Make it possible to define translation for properties and create a message group for Translate extension, similar to what CentralNotice does (sending strings for translation to Translate message groups).
    1. There are lot of places where properties are displayed: many special pages, queries, property pages. Some thinking is required to find out a sensible way to handle translations on all these places.
    2. In most wikis, properties names are supposed to be hidden to the user, e.g. queries results are usually shown in infobox-like templates (whose labels could in theory be localised as all templates).

Translate would be fed with the strings in need of translation. Localised strings/messages would be displayed based on the interface language, that in core every user can set on Special:Preferences and with ULS is made way easier to pick for everyone including unregistered users.

For real field testing, WikiApiary could be used, or at worst translatewiki.net (quick deployments, little SMW content).

For further material, see https://www.mediawiki.org/wiki/Multilingual_Semantic_MediaWiki and follow the links.

See also:

Project characteristics:

  • Skills: PHP and web frontend; having used Semantic MediaWiki and Semantic Forms is a plus.
  • Suggested micro-task: reproduce and submit a patch for one of the bugs linked above; then get it merged, or get an i18n bug fixed (see the list at T40638 under "Blocked by" and the list of open Language Engineering bugs); then feel free to contact the mentors about this project.
  • Mentors: Niklas Laxström, Federico Leva, Yaron Koren.
  • Estimated project time for a senior contributor: 2-3 weeks
bzimport set Reference to bz46522.
bzimport added a subscriber: Unknown Object (MLST).
Qgil created this task.Mar 25 2013, 1:17 AM

Any more details on how one would make SMW multilingual? Or how integration with Translate would work?

Qgil added a comment.Mar 25 2013, 1:44 AM

Not yet, the same entry at the wiki page reads:

"Disclaimer: This a long list proposal. The team will assess this long list on 2013-03-28 and update it with more specific information, or retract it."

I asked Siebrand please please to post a list of potential GSOC 2013 projects. He said he only had time to list ideas that would be reviewed next Thursday at the WMF Language team meeting. I'm grateful he did (our GSOC deadline is Friday), and I'm trying to help getting more feedback from other sources. In this case it made sense to ask the SMW maintainers here.

Thank you for your understanding.

Qgil added a comment.Mar 28 2013, 11:16 PM

There are more details now at http://www.mediawiki.org/wiki/Mentorship_programs/Possible_projects#Multilingual_SemanticMediaWiki

Some of the steps could be:

  • Fix the issues that prevent full localisation of semantic forms.
  • Enhance Special:CreateForm and friends to create forms that are already i18ned with placeholders and message group for Translate extension.
  • Make it possible to define translation for properties and create a message group for Translate extension
    • There are lot of places where properties are displayed: many special pages, queries, property pages. Some thinking is required to find out a sensible way to handle translations on all these places.

Question: are there existing bug reports about this issues? If so please let's make them blockers of this one in order to provide more information to potential volunteers.

This is a proposal coming from the WMG Language team but it needs the buy-in and help from the SMW maintainers before I can move it to the Featured section, where it will be explicitly promoted to potential GSOC & OPW candidates.

Question: are there existing bug reports about this issues?

Not AFAIK.

The two first points seem to be SF specific. The other two indeed need more thought, and need further specification. I suspect they will not be easy to implement.

Unknown Object (User) added a comment.Mar 28 2013, 11:41 PM
  • Make it possible to define translation for properties and create a message group for Translate extension
    • There are lot of places where properties are displayed: many special pages, queries, property pages. Some thinking is required to find out a sensible way to handle translations on all these places.

My 3 cents, since SMW needs to function with or without a Translate extension in mind, the translated text should probably go into a separate blob table with a property tracking id, language key, and its translation. Some setter/getters to catch the representation based on the language key returning a Message object.

Also some enlightenment about how and what the Translate extension actually does and how it would interact might be helpful (can't really picture the Translate extension).

How does the ULS would come into play with this?

Qgil added a comment.Mar 28 2013, 11:51 PM

You can see the Translate extension in action at

https://www.mediawiki.org/wiki/Help:Extension:Translate/Page_translation_example

https://www.mediawiki.org/wiki/How_to_contribute

and many other pages at http://mediawiki.org

Look at the Edit views to see the tags inserted. Then there is a backend for admins and translators to notify new translatable versions of a page, see % of completion per language and so on.

Unknown Object (User) added a comment.Mar 29 2013, 12:15 AM

(In reply to comment #6)

You can see the Translate extension in action at

https://www.mediawiki.org/wiki/Help:Extension:Translate/
Page_translation_example

Fair enough.

<< Example
Fréttinga is a small municipality in MungoLand, located on the [[Located at::BaMungo island]].
It hosts a population of about 400 people. It has some agriculture and fishing.
Tourists like to visit it in the summer time.
...

Within the text you have some annotations (such as [[Located at::BaMungo island]]), what would the Translate extension do now? Provide an event to catch the translation? Should SMW look in the parserOutput for something that says "I have a translation, please handle me differently?"!

Should SMW look for <translate></translate> and somehow find out about the original and the translated copy.

Should free-text annotations (as above) be considered at all or should the focus be on SpecialProperties [1] only?

This is what I meant by "can't really picture the Translate extension" mainly about how the Translate extension and SMW should work together and what is the expected outcome.

[1] http://www.semantic-mediawiki.org/wiki/Special_properties

Translate extension would provide the translation interface. SMW would register a message group(s) to Translate. One of these groups would contain all the *name* of the properties known to exist in the wiki.

The above part is easy. The harder part is to use those translations in various places. Most cases are probably easy to change, but there can be a lot of them and some of them might be difficult because of caching or other issues.

I would leave inline syntax out of scope. There is enough to do with templates and forms.

To give you some idea: Something like this but automated and integrated to Translate (I've spent considerable time doing these by hand):
Forms: http://tieteentermipankki.fi/mediawiki/index.php?title=Lomake:K%C3%A4site&action=edit
Templates: http://tieteentermipankki.fi/mediawiki/index.php?title=Malline:K%C3%A4site&action=edit (only partially i18ned)

jodi.a.schneider wrote:

Some of the steps could be:

  • Fix the issues that prevent full localisation of semantic forms.

Is there a list of known issues? Or how would I go about tracking these down?

Qgil added a comment.Apr 22 2013, 4:36 PM

Background: Jodi is interested in this project in the context of Google Summer of Code. However, so far there is no unanimous opinion between Semantic MediaWiki maintainers.

Either we get a fast agreement or Jodi should go for another project proposal, since GSoC deadlines are close.

I don't think the issue here is unaminity - just lack of communication. I have the greatest respect for the Translatewiki/Translate extension developers, and I think this project makes a lot of sense in theory, but I don't think they've explained enough yet about how this project would work, either here or on the SMW mailing list(s), for it to happen for this GSoC, given the upcoming deadline. I do hope we can have a full discussion about it soon, ideally on the semediawiki-devel list.

Thanks Yaron. Can you help me by pointing what questions I should answer wrt to the integration. Can you also start the discussion on smw-devel or should I or Jodi do that?

Hi Niklas - ideally you can do that, by sending an email fully describing this idea: what the Translate extension does, how it could be used by SMW and SF, what prevents that usage from happening now, and maybe how long you think it would take to fix.

vladjohn2013 wrote:

Hi, this project is still listed at https://www.mediawiki.org/wiki/Mentorship_programs/Possible_projects#Multilingual_SemanticMediaWiki

Should this project be still listed in that page? If not, please remove it. If it still makes sense, then it could be moved to the "Featured projects" section if it has community support and mentors.

rishimittal_ajmer wrote:

Hi everyone ,

The project is not clear , can someone tell me is it part of GSOC-2014 or not.

thanks
Rishi Mittal

See comment 11 (I guess).

(In reply to Rishi Mittal from comment #15)

The project is not clear , can someone tell me is it part of GSOC-2014 or
not.

Yes, it is; we also clarified the description recently. Please ask questions on the project in public, for instance on this bug; or on the talk page of your proposal as soon as you create it (which should be immediately, even if it's incomplete and you have to work on it).

Qgil added a comment.Sep 12 2014, 9:43 AM

FOSS OPW round 9 is about to start. Do you still want to feature this project at https://www.mediawiki.org/wiki/Mentorship_programs/Possible_projects#Multilingual_Semantic_MediaWiki and are there mentors available?

Qgil triaged this task as "Lowest" priority.Feb 11 2015, 12:56 PM
Qgil added a comment.Feb 11 2015, 1:44 PM

Wikimedia will apply to Google Summer of Code and Outreachy on Tuesday, February 17. If you want this task to become a featured project idea, please follow these instructions.

Nemo_bis edited the task description. (Show Details)Feb 11 2015, 3:08 PM
Nemo_bis set Security to None.
Nemo_bis raised the priority of this task from "Lowest" to "Needs Triage".
Nemo_bis edited the task description. (Show Details)Feb 11 2015, 3:38 PM
Nemo_bis edited the task description. (Show Details)Feb 11 2015, 3:42 PM
Qgil added a comment.Feb 12 2015, 11:55 AM

Just checking, are @Nikerabbit and @Yaron_Koren confirmed as primary mentor and co-mentor, respectively?

Niklas is, Yaron I didn't ask yet.

I just saw this now - yes, I'd definitely be willing to serve as a co-mentor for this project.

Qgil edited the task description. (Show Details)Feb 22 2015, 10:54 AM
Rits added a subscriber: Rits.Mar 4 2015, 9:33 PM

Hi,

I would like work on this project as part of GSOC 2015. I understand that the main goal of this project is to integrate MediaWiki with the Translate extension, so that it benefits from it's multilingual capabilities out of the box.

I was not able to understand "There are lot of places where properties are displayed: many special pages, queries, property pages. Some thinking is required to find out a sensible way to handle translations on all these places", point of the project description completely. What properties are we talking about here?

Also I have been working on getting the bug T85924 resolved and have got some insights as to how messages are fetched and displayed to the user and the coding standards.

I would greatly appreciate suggestions as to how can I get started on this project, to get better understanding of the challenges in the project.

Thanks

Also I have been working on getting the bug T85924 resolved and have got some insights as to how messages are fetched and displayed to the user and the coding standards.

Sure, we can continue in gerrit. In the meanwhile, the best way to progress is sending more patches in gerrit for the bugs which you do understand. :)

Nemo_bis edited the task description. (Show Details)Mar 10 2015, 10:42 PM
Nemo_bis edited the task description. (Show Details)Mar 16 2015, 10:35 AM
Nemo_bis edited the task description. (Show Details)Mar 17 2015, 8:47 AM

We're holding an IRC meeting on March 25, at 1700 UTC for prospective GSoC and Outreachy participants with Wikimedia, on #wikimedia-office channel. Do join us!

Hi @Nemo_bis, I would like to submit a proposal for this project. Besides updating the page on google-melange website, could you tell me if there are any other requirements.

Also I was not able to understand the following point of the project description :- "There are lot of places where properties are displayed: many special pages, queries, property pages. Some thinking is required to find out a sensible way to handle translations on all these places". Could you tell me what properties are we talking about here?

Thanks

I would like to submit a proposal for this project. Besides updating the page on google-melange website, could you tell me if there are any other requirements.

This should be covered by https://www.mediawiki.org/wiki/Google_Summer_of_Code_2015#Add_your_proposal - if anything is unclear, please ask.

Hello! The IRC meeting tomorrow has been shifted to #wikimedia-ect channel. Looking forward to seeing you there. :)

Happily, I am able to create a multilingual semform by a) using {{UILANGCODE}} in switches and b) using the 'mapping template' parameter on the {{{field}}} statement where {{UILANGCODE}} is used to select translated text values for properties of the page.

My great thanks to those who added the 'mapping template' to {{{field}}} !

Qgil added a comment.Sep 23 2015, 9:00 AM

@Nikerabbit @Nemo_bis @Yaron_Koren this project is still featured at Possible-Tech-Projects. Do you want to propose it for Outreachy-Round-11 for December-March?

Qgil added a comment.Sep 23 2015, 9:36 AM

This is a message sent to all Possible-Tech-Projects. The new round of Wikimedia Individual Engagement Grants is open until 29 Sep. For the first time, technical projects are within scope, thanks to the feedback received at Wikimania 2015, before, and after (T105414). If someone is interested in obtaining funds to push this task, this might be a good way.

The topic is still valid and a useful feature for semantic wikis.

However, I am very hesitant about proposing anything for a while due to the fact that both the Language team (my work time) and my free time are already overloaded.

I don't do Outreachy, so this project might be a no-go for now. However, it might be worth re-discussing this project (@Nikerabbit - presumably with you) in light of the new-ish Cargo extension, which can be used in place of SMW; hopefully there can be a solution that works equally well with both systems. Then again, just accomplishing the tasks currently listed would be a big step forward.

Soum213 added a subscriber: Soum213.Oct 8 2015, 5:09 PM

This is the last call for Possible-Tech-Projects missing mentors. The application deadline for Outreachy-Round-11 is 2015-11-02. If this proposal doesn't have two mentors assigned by the end of Thursday, October 22, it will be moved as a candidate for the next round.

Interested in mentoring? Check the documentation for possible mentors.

As previously mentioned, this task is moved to 'Recheck in February 2016' as it doesn't have two mentors assigned to it as of today, October 23 - 2015. The project will be included in the discussion of next iteration of GSoC/Outreachy, and is excluded from #Outreachy-11. Potential candidates are discouraged from submitting proposals to this task for #Outreachy-11 as it lacks mentors in this round.

Restricted Application added a subscriber: StudiesWorld. · View Herald TranscriptNov 20 2015, 11:30 AM
Sumit added a subscriber: Sumit.Feb 18 2016, 1:33 PM
NOTE: This task is a proposed project for Google-Summer-of-Code-2016 and Outreachy-Round-12 : GSoC 2016 and Outreachy round 12 is around the corner, and this task is listed as a Possible-Tech-Projects for the same. Projects listed for the internship programs should have a well-defined scope within the timeline of the event, minimum of two mentors, and should take about 2 weeks for a senior developer to complete. Interested in mentoring? Please add your details to the task description, if not done yet. Prospective interns should go through Life of a successful project doc to find out how to come up with a strong proposal for the same.
Niharika removed a subscriber: Niharika.Feb 19 2016, 3:21 AM
Nemo_bis closed this task as "Invalid".Feb 27 2016, 6:04 PM

One open blocker, not clear what else is left. Niklas said he'll fix all the things himself while proceeding with his MSMW contracts.

Restricted Application removed a subscriber: Liuxinyu970226. · View Herald TranscriptFeb 27 2016, 6:04 PM

Add Comment